﻿Imports System.Net.NetworkInformation

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub ParallelPing(sender As Object, e As EventArgs)
        Dim sites As New List(Of String)
        sites.Add("www.yahoo.com")
        sites.Add("www.google.com")
        sites.Add("www.aspsnippets.com")

        Dim pingReplies As New List(Of PingReply)()
        System.Threading.Tasks.Parallel.ForEach(sites, Sub(site)
                                                           Dim p As New Ping()
                                                           SyncLock pingReplies
                                                               pingReplies.Add(p.Send(site))
                                                           End SyncLock
                                                       End Sub)


        For Each s In pingReplies.ToList()
            Response.Write(Convert.ToString(s.Address) & ": " & Convert.ToString(s.RoundtripTime) & ": " & Convert.ToString(s.Status) & "<br />")
        Next

    End Sub
End Class
